--[[
	Copyright (C) Udorn (Blackhand)
--]]

local viewType = "QuestPopups"
local version = 1
local YakaGui = LibStub("YakaGui", true)
local info = YakaGui:GetViewInfo(viewType) 
if (info and info.version >= version) then 
	return 
end

qmstr = qmstr or {}
qmstr.QuestPopups = {}
qmstr.QuestPopups.prototype = {}
qmstr.QuestPopups.metatable = {__index = qmstr.QuestPopups.prototype}
setmetatable(qmstr.QuestPopups.prototype, {__index = yaka.View.prototype})

qmstr.QuestPopups.info = {viewType = viewType, version = version}
qmstr.QuestPopups.GetViewInfo = function()
	return qmstr.QuestPopups.info
end

local log = vendor.Debug:new("QuestPopups")

--[[ 
	Creates a new instance.
--]]
function qmstr.QuestPopups:new(cfgIn)
	local instance = setmetatable({}, self.metatable)
	instance:InitCfg(cfgIn)
	instance:InitFrame()
	return instance
end

function qmstr.QuestPopups.prototype:InitFrame()
	local frame = CreateFrame("Frame")
	
	-- WatchFrameAutoQuest_DisplayAutoQuestPopUps needs this
	frame.AutoQuestShadow = WatchFrameLinesAutoQuestShadow
	
	self.frame = frame
	
	yaka.View.prototype.InitFrame(self)
end

function qmstr.QuestPopups.prototype:GetMeasuredHeight()
	local height = 0

	for _, child in ipairs({self.frame:GetChildren()}) do
		--log:Debug("found child [%s] height [%s] shown [%s]", child, child:GetHeight(),  child:IsShown())
		if (child:IsShown()) then
			height = height + child:GetHeight()
		end
	end
	
	--log:Debug("GetMeasuredHeight rtn [%s]", height)
	
	return height
end

function qmstr.QuestPopups.prototype:GetMeasuredWidth()
	return self.maxLineWidth or "fill"
end

function qmstr.QuestPopups.prototype:DisplayAutoQuestPopUps(nextAnchor, maxHeight, frameWidth)
	local h = self:GetMeasuredHeight()
	local nextAnchor, maxLineWidth, numObjectives = WatchFrameAutoQuest_DisplayAutoQuestPopUps(self.frame, nil, maxHeight, frameWidth)
	self.maxLineWidth = maxLineWidth 
	self.frame.AutoQuestShadow:Hide()
	local heightChanged = h ~= self:GetMeasuredHeight()
	return nextAnchor, maxLineWidth, numObjectives, heightChanged
end

-- register view

YakaGui:RegisterViewType(qmstr.QuestPopups)